#ifndef MESH_H
#define MESH_H

typedef struct {
	double *points;
	int width;
	int height;
	float lowColor[4];
	float highColor[4];
	double highValue;
} Mesh;


Mesh *createMesh(int width, int height);
void freeMesh(Mesh *mesh);
void drawMesh(Mesh *mesh);
void drawMeshCircle(Mesh *mesh);
void propagateSine(Mesh *mesh);
void propagateWave(Mesh *mesh);
float findAverageDerivative(Mesh *mesh, double *lastValues);


#endif
