#include <gtk/gtk.h>

#include <xmms/plugin.h>
#include "xmms/configfile.h"


GtkWidget *configure_win = NULL;
int desiredMode = 0;
double lowColorArray[4];
double highColorArray[4];


void configure_ok(GtkWidget *w, gpointer data)
{
	ConfigFile *cfg;	
	gchar *filename;
	int i;
	char lowname[10];
	char highname[10];
	

	filename = g_strconcat(g_get_home_dir(), "/.xmms/config", NULL);
	cfg = xmms_cfg_open_file(filename);
	if (!cfg)
		cfg = xmms_cfg_new();
	xmms_cfg_write_int(cfg, "ZoN", "Mode", desiredMode);
	for(i = 0; i < 4; i++)
	{
		sprintf(lowname,"low%d",i);
		sprintf(highname,"high%d",i);
		xmms_cfg_write_double(cfg,"ZoN",lowname,lowColorArray[i]);
		xmms_cfg_write_double(cfg,"ZoN",highname,highColorArray[i]);
	}
	


	xmms_cfg_write_file(cfg, filename);
	xmms_cfg_free(cfg);
	g_free(filename);
	
/*	gtk_widget_destroy(configure_win);*/
}

void zon_configure (void)
{
	if(configure_win)
	{
		printf("configure_win: 0x%x\n",configure_win);
		return;
	}


	configure_win = create_configWindow();
	gtk_widget_show(configure_win);
}


