/*
		Zon

         Copyright (c) 2000-2001 by Jared Maguire
 Freely redistributable under the Gnu GPL version 2 or later

*/

   
 
#include <xmms/plugin.h>  
#include <stdlib.h>
#include <stdio.h>
#include <glib.h> 
#include <math.h>
#include <pthread.h>
#include "gluthack.h"
#include "struct.h"
#include "configure.h"

static void zon_init(void);
static void zon_cleanup(void);
static void zon_playback_start(void);
static void zon_playback_stop(void);
static void zon_render_pcm(gint16 data[2][512]);
static void zon_render_freq(gint16 data[2][256]);
static void zon_disable(void);


VisPlugin zon_vp =                
{                           
  NULL,
  NULL, 
  0,                             
  "Zon, V0.04",                               
  2,                            
  2,      
  zon_init, /* init */  
  zon_cleanup, /* cleanup */
  NULL, /* about */                  
  zon_configure, /* configure */         
  zon_disable, /* disable_plugin */
  zon_playback_start, /* playback_start */ 
  zon_playback_stop, /* playback_stop */       
  zon_render_pcm, /* render_pcm */
  zon_render_freq  /* render_freq */
};  

guint *table1,*table2,*table3,*table4,pitch;
guint8 dim[256],dim2[256],*bits,bpp,*pixel,*buffer,*buffer2;
struct conteur_struct conteur;

pthread_t *displayThread;

VisPlugin *get_vplugin_info(void) 
{    
  return &zon_vp;           
}   

void zon_init(void)
{  
  //   printf("init\n"); fflush(stdout);

  killFlag = 0;
  displayThread = setupDisplayThread();   
  pthread_detach(*displayThread);
   if(configFilePtr)
	{
		fclose(configFilePtr);
	}
}

static void zon_cleanup(void)
{  
   //printf("cleanup\n"); fflush(stdout);
   pthread_mutex_unlock(&pcmDataToDraw);
   pthread_mutex_unlock(&freqDataToDraw);
   pthread_mutex_unlock(&colorMutex);
   killFlag = 1;
   
}

static void zon_disable(void)
{  
   //printf("disable\n"); fflush(stdout);
}
  
static void zon_playback_start(void)
{ 
  //   printf("Playback_start\n"); fflush(stdout); 
   sprintf(configFileName, "%s/ZoN.rc", TEXTURE_DIR);
   //configFilePtr = fopen(configFileName, "a");
   
}

static void zon_playback_stop(void)
{ 
  //   printf("Playback_stop!\n"); fflush(stdout); 
   //if(configFilePtr)
//	{
//		fclose(configFilePtr);
//	}
}

static void zon_render_pcm(gint16 data[2][512])
{  
  int i;

  //put the data where the drawing thread can see it.
  if(pthread_mutex_trylock(&pcmDataToDraw)) return;;
  memcpy(pcmData, data, sizeof(gint16) * 2 * 512);

  pthread_mutex_unlock(&pcmDataToDraw);
  //Throw up the 'new data to draw' flag
  drawFlag = 1;
  fflush(stdout);

}

static void zon_render_freq(gint16 data[2][256])
{
  int i;
 
  if(pthread_mutex_trylock(&freqDataToDraw)) return;;
  memcpy(freqData, data, sizeof(gint16) * 2 * 256);

  pthread_mutex_unlock(&freqDataToDraw);

}
